import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.text.*;

public class calendario extends Frame implements ActionListener{
	static String[] ARRMES = {"Enero","Febrero","Marzo","Abril","Mayo","Junio","Julio","Agosto","Septiembre","Octubre","Noviembre","Diciembre"};
	static String[] ARRDIASSEMANA = {"Dom","Lun","Mar","Mie","Jue","Vie","Sab"};
    static Calendar currentDate;
	static Label meslabel;    
    Button anomenos;
    Button mesmenos;
    Button mesmas;
    Button anomas;
    Label label_2;
    Label label_3;
    Label label_4;
    Label label_5;
    Label label_6;
    Label label_7;
    Label label_8;
	int	MesAnterior;
	int	MesSiguiente;
	int	AnoAnterior;
	int	AnoSiguiente;
	int	AnoAnteriorAno;
	int	AnoSiguienteAno;	
	int a;	
	static int mes;	

    public calendario() {
        calendarioLayout customLayout = new calendarioLayout();
		currentDate = Calendar.getInstance(); 
        setFont(new Font("Helvetica", Font.PLAIN, 12));
        setLayout(customLayout);

        anomenos = new Button("<<");
        add(anomenos);
        anomenos.addActionListener(this);

        mesmenos = new Button("<");
        add(mesmenos);
        mesmenos.addActionListener(this);

        meslabel = new Label("");
        add(meslabel);

        mesmas = new Button(">");
        add(mesmas);
        mesmas.addActionListener(this);

        anomas = new Button(">>");
        add(anomas);
        anomas.addActionListener(this);

        label_2 = new Label("Lun");
        add(label_2);

        label_3 = new Label("Mar");
        add(label_3);

        label_4 = new Label("Mie");
        add(label_4);

        label_5 = new Label("Jue");
        add(label_5);

        label_6 = new Label("Vie");
        add(label_6);

        label_7 = new Label("Dom");
        add(label_7);

        label_8 = new Label("Sab");
        add(label_8);

        setSize(getPreferredSize());

        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
    }

	public static void main(String Arg[ ]) throws IOException{
		
		calendario window = new calendario();
        window.setTitle("CALENDARIO");
        window.pack();
        window.show();      
	}

	public void paint(Graphics g)
	{
		int b=0;
		int c=1;
		int tmp;
		int x = 50;
		int y = 130;
		int dia = currentDate.get(currentDate.DATE);
		mes = currentDate.get(currentDate.MONTH);
		mes++;
		int ano = currentDate.get(currentDate.YEAR);
		int TotalDiasMes = currentDate.getActualMaximum(currentDate.DAY_OF_MONTH);
		if (dia>currentDate.get(currentDate.DAY_OF_WEEK))
			tmp = dia-currentDate.get(currentDate.DAY_OF_WEEK);
		else
			tmp = currentDate.get(currentDate.DAY_OF_WEEK)-dia;
		
		while (tmp>7){
			tmp=tmp-7;
		}
		
		tmp=8-tmp;	
		int DiaSemanaEmpiezaMes = tmp;
	
		tmp = dia-currentDate.get(currentDate.DAY_OF_WEEK);

		while((tmp+7)<TotalDiasMes){
			tmp=tmp+7;
		}
		tmp=TotalDiasMes-tmp;
		
		int DiaSemanaTerminaMes = tmp;

		mes = currentDate.get(currentDate.MONTH);
		meslabel.setText(" "+ARRMES[mes]+" del "+currentDate.get(currentDate.YEAR));
		int j=1;
		int aux=0;
		for(int i=0; i<TotalDiasMes+DiaSemanaEmpiezaMes-1 ; i++){
			aux++;
			if (aux==8){
				aux=1;
				x = 50;
				y = y + 25; 
			}
			if (i<DiaSemanaEmpiezaMes-1){
			  	x = x + 56;
			  }
			else{ 
			 	if (j<10){
			 		g.drawString("0"+String.valueOf(j), x, y);
			 		x = x + 56;
			 	}
			 	else{
			 		g.drawString(String.valueOf(j), x, y);
			 		x = x + 56;
			 	}
				j++;
			}
		}	  	

	}	
	
    public void actionPerformed(ActionEvent ae) {
		int dia;
		int mes;
		int ano;
		if (ae.getSource() == anomenos){
				mes = currentDate.get(currentDate.MONTH);
				dia = currentDate.get(currentDate.DATE);
				ano = currentDate.get(currentDate.YEAR);
				ano = ano - 1;
				currentDate.set(ano,mes,dia);
				repaint();
		}
		if (ae.getSource() == anomas){
				mes = currentDate.get(currentDate.MONTH);
				dia = currentDate.get(currentDate.DATE);
				ano = currentDate.get(currentDate.YEAR);
				ano = ano + 1;
				currentDate.set(ano,mes,dia);
				repaint();
		}		
		if (ae.getSource() == mesmenos){
				mes = currentDate.get(currentDate.MONTH);
				dia = currentDate.get(currentDate.DATE);
				ano = currentDate.get(currentDate.YEAR);
				mes = mes - 1;
				currentDate.set(ano,mes,dia);
				repaint();
		}		
		if (ae.getSource() == mesmas){
				mes = currentDate.get(currentDate.MONTH);
				dia = currentDate.get(currentDate.DATE);
				ano = currentDate.get(currentDate.YEAR);
				mes = mes + 1;
				currentDate.set(ano,mes,dia);
				repaint();
		}		
	}
}

class calendarioLayout implements LayoutManager {

    public calendarioLayout() {
    }

    public void addLayoutComponent(String name, Component comp) {
    }

    public void removeLayoutComponent(Component comp) {
    }

    public Dimension preferredLayoutSize(Container parent) {
        Dimension dim = new Dimension(0, 0);

        Insets insets = parent.getInsets();
        dim.width = 475 + insets.left + insets.right;
        dim.height = 260 + insets.top + insets.bottom;

        return dim;
    }

    public Dimension minimumLayoutSize(Container parent) {
        Dimension dim = new Dimension(0, 0);
        return dim;
    }

    public void layoutContainer(Container parent) {
        Insets insets = parent.getInsets();

        Component c;
        c = parent.getComponent(0);
        if (c.isVisible()) {c.setBounds(insets.left+40,insets.top+24,56,32);}
        c = parent.getComponent(1);
        if (c.isVisible()) {c.setBounds(insets.left+104,insets.top+24,56,32);}
        c = parent.getComponent(2);
        if (c.isVisible()) {c.setBounds(insets.left+168,insets.top+24,128,32);}
        c = parent.getComponent(3);
        if (c.isVisible()) {c.setBounds(insets.left+304,insets.top+24,56,32);}
        c = parent.getComponent(4);
        if (c.isVisible()) {c.setBounds(insets.left+368,insets.top+24,56,32);}
        c = parent.getComponent(5);
        if (c.isVisible()) {c.setBounds(insets.left+96,insets.top+64,48,24);}
        c = parent.getComponent(6);
        if (c.isVisible()) {c.setBounds(insets.left+152,insets.top+64,48,24);}
        c = parent.getComponent(7);
        if (c.isVisible()) {c.setBounds(insets.left+208,insets.top+64,48,24);}
        c = parent.getComponent(8);
        if (c.isVisible()) {c.setBounds(insets.left+264,insets.top+64,48,24);}
        c = parent.getComponent(9);
        if (c.isVisible()) {c.setBounds(insets.left+320,insets.top+64,48,24);}
        c = parent.getComponent(10);
        if (c.isVisible()) {c.setBounds(insets.left+40,insets.top+64,48,24);}
        c = parent.getComponent(11);
        if (c.isVisible()) {c.setBounds(insets.left+376,insets.top+64,48,24);}
    }
}